'use strict';

var _ = require('lodash');
var KindaObject = require('kinda-object');
var KindaLog = require('kinda-log');
var httpClient = require('kinda-http-client').create();

var SlackIncomingWebhookTarget = KindaObject.extend('SlackIncomingWebhookTarget', function () {
  this.creator = function () {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _.defaults(options, { channel: '#general' });
    if (!options.url) throw new Error('url is missing');

    this.url = options.url;
    this.channel = options.channel;
    var log = options.log;
    if (!KindaLog.isClassOf(log)) log = KindaLog.create(log);
    this.log = log;
  };

  this.send = function callee$1$0(sender, title, message) {
    var payload, result;
    return regeneratorRuntime.async(function callee$1$0$(context$2$0) {
      while (1) switch (context$2$0.prev = context$2$0.next) {
        case 0:
          if (title) message = '*' + title + '*: ' + message;
          payload = {
            channel: this.channel,
            username: sender,
            text: '<!channel> ' + message
          };
          context$2$0.next = 4;
          return regeneratorRuntime.awrap(httpClient.post({ url: this.url, body: payload, json: true }));

        case 4:
          result = context$2$0.sent;

          if (result.body !== 'ok') {
            this.log.error(new Error('an error occured while sending a Slack notification (' + result.body + ')'));
          }

        case 6:
        case 'end':
          return context$2$0.stop();
      }
    }, null, this);
  };
});

module.exports = SlackIncomingWebhookTarget;